<h1 id="reading-writing-documentation">Reading &amp; Writing Documentation</h1>
<h3 id="projected-time">Projected Time</h3>
<p>About 2 hours</p>
<ul>
<li>15 minutes for video walkthrough of slides</li>
<li>15 minutes for “Python Basics: Documentation" (video)</li>
<li>10 minutes for “How to Find and Read API Documentation" (video)</li>
<li>10 minutes for “15 Technical Writing Tips" (video)</li>
<li>20 minutes for Group Practice</li>
<li>30 minutes for Independent Practice</li>
<li>15 minutes for Check for Understanding</li>
</ul>
<h3 id="prerequisites">Prerequisites</h3>
<ul>
<li><a href="/asking-good-questions/asking-good-questions.md">Asking Good Questions lesson</a></li>
<li>Completion of Techtonica’s HTML/CSS &amp; JS workshops (ie: you can recognize HTML, CSS and JS code)</li>
</ul>
<h3 id="motivation">Motivation</h3>
<p>Software engineers frequently reference a language’s or a framework’s documentation to understand how to use some part of that technology. It’s therefore important to know how documentation is intended to help you, and also how to read it effectively and efficiently.</p>
<p>You will someday want to write documentation for a project you’re working on in order to tell or show others how to use the project.</p>
<p>This is such an important topic in software development that many IDE companies provide languages specific extensions to help incorporate and standardize documentation in your code. For example Apple provides this support for Swift in Xcode https://developer.apple.com/library/archive/documentation/Xcode/Reference/xcode_markup_formatting_ref/SymbolDocumentation.html. For JavaScript the Mozilla organization (originally Netscape) created the industry standard JSDoc https://en.wikipedia.org/wiki/JSDoc supported by many IDEs including Microsoft’s VSCode.</p>
<h3 id="objectives">Objectives</h3>
<p><strong>Participants will be able to:</strong></p>
<ul>
<li>Add useful comments to their code</li>
<li>Read documentation for the purpose of extracting specific information</li>
<li>Write useful, easy-to-follow documentation</li>
</ul>
<h3 id="specific-things-to-learn">Specific Things to Learn</h3>
<ul>
<li>Inline comments in HTML, CSS and JavaScript</li>
<li>How to read documentation</li>
<li>Best practices for writing documentation</li>
</ul>
<h3 id="lesson">Lesson</h3>
<ul>
<li><p><a href="https://drive.google.com/file/d/1D6hUb6Z-EXYjzsrM3C4WOQ31ZWmtbmzh/view?usp=sharing">Reading &amp; Writing Documentation (video walkthrough of slides)</a></p></li>
<li><p><a href="https://docs.google.com/presentation/d/18CJBM1Z6IA4MGGy6phf2bJN5gOrzQ64y1coIMcq8te0/edit?usp=sharing">Reading &amp; Writing Documentation (slides)</a></p></li>
</ul>
<h3 id="common-mistakes-misconceptions">Common Mistakes / Misconceptions</h3>
<ul>
<li><p><strong>Make sure your comments will make sense to someone with little context for what you were trying to do at the time you wrote the code.</strong> This could be a teammate or even your future self!</p></li>
<li><p><strong>Comments should document the present and occasionally the future, but they should not be used to describe history.</strong> That’s what version control is for (we’ll learn about version control soon).</p></li>
<li><p><strong>Don’t use bad words in comments.</strong></p></li>
<li>
    <p><strong>“I’ll just add comments to as much of my code as possible so there will be no confusion later."</strong>
        This is actually not a good practice. Your variable names and function names should be so descriptive that
        comments would be redundant. Use comments only to explain things that are not easily apparent by reading the
        code.</p>
</li>
</ul>
<h3 id="demonstration">Demonstration</h3>
<p>Via instructor-led Group Practice.</p>
<h3 id="group-practice">Group Practice</h3>
<p>Look at <a href="https://repl.it/repls/MelodicSilkyQueenbee">this JavaScript code snippet</a> together and talk through it line-by-line. Change some of the variable names and function names to make them more descriptive. Add/remove comments where appropriate.</p>
<h3 id="independent-practice">Independent Practice</h3>
<ol type="1">
<li><p>Find the JavaScript documentation online.</p></li>
<li><p>Locate the entry for the <code>.concat()</code> array method. What does it do? Open a new file in <a href="http://www.repl.it">REPL.it</a> and use the <code>.concat()</code> method correctly on an example of your choosing.</p></li>
<li><p>Locate the entry for the <code>.fill()</code> array method. What does it do? Open a new file in <a href="http://www.repl.it">REPL.it</a> and use the <code>.fill()</code> method correctly on an example of your choosing.</p></li>
<li><p>Locate the entry for the <code>.reverse()</code> array method. What does it do? Open a new file in <a href="http://www.repl.it">REPL.it</a> and use the <code>.reverse()</code> method correctly on an example of your choosing.</p></li>
</ol>
<h3 id="challenge">Challenge</h3>
<p>Locate the entry for a string method of your choice. What does it do? Open a new file in <a href="http://www.repl.it">REPL.it</a> and use the method correctly on an example you made up.</p>
<p>Instructor asks for a volunteer to come up to the board and write out a proper implementation of one of the array methods studied during the Independent Practice. Classmates can assist if necessary. Anyone who discovered more methods during the Challenge section may also share those with the class.</p>
<h3 id="check-for-understanding">Check for Understanding</h3>
<ul>
<li>Why is it important to document your code?</li>
<li>What should comments do?</li>
<li>What are the two types of comments in JavaScript? What is it used for?</li>
<li>What is Markdown?</li>
<li>Find an example of a github project with good documentation or an API. Explain why it’s good documentation or not.</li>
<li>What can be improved?</li>
</ul>
<h3 id="supplemental-materials">Supplemental Materials</h3>
<ul>
<li><a href="https://www.youtube.com/watch?v=E7fDz2Gm0mI">Python Basics: Documentation (video)</a></li>
<li><p><a href="https://www.youtube.com/watch?v=xjU8LBQu53U">How to Find and Read API Documentation (video)</a></p></li>
<li><p><a href="https://guides.github.com/features/mastering-markdown/">Mastering Markdown (online tutorial documentation)</a></p></li>
</ul>
